; HELLO WORLD!
; (C) 2002-2005, Andreas Berg. All Rights Reserved.

.model tiny                            ; Tiny model
.com                                   ; Set to com file
.org 100h                              ; ORG 100h

push  cs                               ; CS -> Stack
pop   ds                               ; stack -> DS

mov   ah,0fh                           ; AH = 0fh (function: Get video info)
int   10h                              ; INT 10h: Call the function
mov   [pageNum],bh                     ; pageNum = bh (storing the page)

lea   si,message                       ; SI -> message

nextChar:
mov   al,byte ptr [si]                 ; AL -> SI[pos]
cmp   al,0                             ; Is AL = 0?
je    endPrint                         ; If yes, jump to "endPrint"
mov   ah,0eh                           ; AH = 0eh (function: Print character)
mov   bh,[pageNum]                     ; BH = pageNum
int   10h                              ; INT 10h: Call then function
inc   si                               ; Point to the next character
jmps  nextChar                         ; Jump to "nextChar"
endPrint:
                                        
int   20h                              ; Terminate COM program

message db 'Hello, World!',13,10,0     ; Hello, World! message
pageNum db 0                           ; Holds the page number

end
